diff --git a/tools/dsymutil/SymbolMap.cpp b/tools/dsymutil/SymbolMap.cpp
index cab9374a..5c2377e4 100644
--- a/tools/dsymutil/SymbolMap.cpp
+++ b/tools/dsymutil/SymbolMap.cpp
@@ -18,8 +18,18 @@
 #ifdef __APPLE__
 #include <CoreFoundation/CoreFoundation.h>
 #include <uuid/uuid.h>
+
+#if MAC_OS_X_VERSION_MAX_ALLOWED < 1060
+/* declare a missing reference not found in SDK < 10.6 for function called below */
+typedef char * uuid_string_t;
+typedef struct __CFError * CFErrorRef;
+#define CFPropertyListCreateWithStream(A,B,C,D,E,F) CFPropertyListCreateFromStream(A,B,C,D,E,F)
+#endif
+
 #endif
 
+
+
 namespace llvm {
 namespace dsymutil {
 
